cmake_minimum_required(VERSION 2.8.3)
project(video)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  linux_devs_device
  custom_loader
  robot_ps_core
  device
  image_transport
  theora_image_transport
  simple_xml_settings
  cv_bridge
  nodelet
  rosbag
  roscpp
  message_generation
)
find_package(OpenCV REQUIRED)
find_package(OpenGL REQUIRED)

## System dependencies are found with CMake's conventions
# find_package(Boost REQUIRED COMPONENTS system)


## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

################################################
## Declare ROS messages, services and actions ##
################################################

## To declare and build messages, services or actions from within this
## package, follow these steps:
## * Let MSG_DEP_SET be the set of packages whose message types you use in
##   your messages/services/actions (e.g. std_msgs, actionlib_msgs, ...).
## * In the file package.xml:
##   * add a build_depend and a run_depend tag for each package in MSG_DEP_SET
##   * If MSG_DEP_SET isn't empty the following dependencies might have been
##     pulled in transitively but can be declared for certainty nonetheless:
##     * add a build_depend tag for "message_generation"
##     * add a run_depend tag for "message_runtime"
## * In this file (CMakeLists.txt):
##   * add "message_generation" and every package in MSG_DEP_SET to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * add "message_runtime" and every package in MSG_DEP_SET to
##     catkin_package(CATKIN_DEPENDS ...)
##   * uncomment the add_*_files sections below as needed
##     and list every .msg/.srv/.action file to be processed
##   * uncomment the generate_messages entry below
##   * add every package in MSG_DEP_SET to generate_messages(DEPENDENCIES ...)

## Generate messages in the 'msg' folder
add_message_files(
   FILES
   Resolution.msg
)

## Generate services in the 'srv' folder
# add_service_files(
#   FILES
#   Service1.srv
#   Service2.srv
# )

## Generate actions in the 'action' folder
# add_action_files(
#   FILES
#   Action1.action
#   Action2.action
# )

## Generate added messages and services with any dependencies listed here
generate_messages(
  DEPENDENCIES
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES video
  CATKIN_DEPENDS linux_devs_device custom_loader robot_ps_core device simple_xml_settings image_transport cv_bridge nodelet rosbag roscpp
# DEPENDS system_lib
)

###########
## Build ##
###########

# Qt 5
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
find_package(Qt5Widgets)
find_package(Qt5OpenGL)
file(GLOB_RECURSE QT_RESOURCES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} resources/*.qrc)
QT5_ADD_RESOURCES(QT_RESOURCES_RCC ${QT_RESOURCES})

## Specify additional locations of header files
## Your package locations should be listed before other locations
# include_directories(include)
include_directories(
  include
  ${QT_INCLUDE_DIRS}
  ${linux_devs_device_INCLUDE_DIRS}
  ${simple_xml_settings_INCLUDE_DIRS}
  ${custom_loader_INCLUDE_DIRS}
  ${robot_ps_core_INCLUDE_DIRS}
  ${device_INCLUDE_DIRS}
  ${image_transport_INCLUDE_DIRS}
  ${cv_bridge_INCLUDE_DIRS}
  ${nodelet_INCLUDE_DIRS}
  ${rosbag_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

## Declare a cpp library
set(VideoDirInclude include/video)
set(VideoDirSrc src/lib)
file (GLOB_RECURSE VideoHeaders "${VideoDirInclude}/*.h" "${VideoDirSrc}/*.h")
file (GLOB_RECURSE VideoSources "${VideoDirSrc}/*.cpp")
add_library(video ${VideoHeaders} ${VideoSources} ${QT_RESOURCES_RCC} )

## Declare a cpp executable
add_executable(web_camera src/web_camera_main.cpp)
add_executable(url_camera src/url_camera_main.cpp)

## Add cmake target dependencies of the executable/library
## as an example, message headers may need to be generated before nodes
# add_dependencies(video_node video_generate_messages_cpp)

## Specify libraries to link a library or executable target against
qt5_use_modules(video Widgets OpenGL)
target_link_libraries(video
  Qt5::Widgets
  ${QT_LIBRARIES}
  ${OPENGL_LIBRARIES}
  ${linux_devs_device_LIBRARIES}
  ${simple_xml_settings_LIBRARIES}
  ${custom_loader_LIBRARIES}
  ${robot_ps_core_LIBRARIES}
  ${device_LIBRARIES}
  ${image_transport_LIBRARIES}
  ${cv_bridge_LIBRARIES}
  ${nodelet_LIBRARIES}
  ${rosbag_LIBRARIES}
  ${catkin_LIBRARIES}
  ${OpenCV_LIBS}
)

target_link_libraries(web_camera
  ${nodelet_LIBRARIES}
  ${catkin_LIBRARIES}
)

target_link_libraries(url_camera
  ${nodelet_LIBRARIES}
  ${catkin_LIBRARIES}
)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
# install(TARGETS video video_node
#   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark cpp header files for installation
# install(DIRECTORY include/${PROJECT_NAME}/
#   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
#   FILES_MATCHING PATTERN "*.h"
#   PATTERN ".svn" EXCLUDE
# )

## Mark other files for installation (e.g. launch and bag files, etc.)
# install(FILES
#   # myfile1
#   # myfile2
#   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
# )

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
# catkin_add_gtest(${PROJECT_NAME}-test test/test_video.cpp)
# if(TARGET ${PROJECT_NAME}-test)
#   target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME})
# endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)




set(CMAKE_BUILD_TYPE Debug)

#add c++11 capabilities
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
